Subject: bug#64580: closed (Re: bug#64580: 30.0.50; Comment describing Lisp_Overlay object in src/lisp.h:2590 is not current)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 13 Jul 2023 08:36:02 +0000

Your bug report

#64580: 30.0.50; Comment describing Lisp_Overlay object in src/lisp.h:2590 is not current

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
64580: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=64580
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#64580: 30.0.50; Comment describing Lisp_Overlay object in src/lisp.h:2590 is not current
From: Eli Zaretskii <[email-masked]>
To: Ihor Radchenko <[email-masked]>
Cc: [email-masked]
Date: Thu, 13 Jul 2023 11:34:50 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Ihor Radchenko <[email-masked]>
> Date: Wed, 12 Jul 2023 12:47:30 +0000
> 
> /* START and END are markers in the overlay's buffer, and
>    PLIST is the overlay's property list.  */
> struct Lisp_Overlay
> /* An overlay's real data content is:
>    - plist
>    - buffer (really there are two buffer pointers, one per marker,
>      and both points to the same buffer)
>    - insertion type of both ends (per-marker fields)
>    - start & start byte (of start marker)
>    - end & end byte (of end marker)
>    - next (singly linked list of overlays)
>    - next fields of start and end markers (singly linked list of markers).
>    I.e. 9words plus 2 bits, 3words of which are for external linked lists.
> */
>   {
>     union vectorlike_header header;
>     Lisp_Object plist;
>     struct buffer *buffer;        /* eassert (live buffer || NULL). */
>     struct itree_node *interval;
>   } GCALIGNED_STRUCT;
> 
> START and END are no longer in the struct. NEXT fields are also no
> longer applicable, even via itree_node struct.

Thanks, fixed on the emacs-29 branch.

Subject: 30.0.50; Comment describing Lisp_Overlay object in src/lisp.h:2590 is not current
From: Ihor Radchenko <[email-masked]>
To: [email-masked]
Date: Wed, 12 Jul 2023 12:47:30 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

I am not reading lisp.h, trying to understand the Lisp object layout.
The comments are generally excellent, but I just stumbled upon
Lisp_Overlay definition, where the comment appears to be outdated and
only reflects the past times when overlays did not yet use itree:

/* START and END are markers in the overlay's buffer, and
   PLIST is the overlay's property list.  */
struct Lisp_Overlay
/* An overlay's real data content is:
   - plist
   - buffer (really there are two buffer pointers, one per marker,
     and both points to the same buffer)
   - insertion type of both ends (per-marker fields)
   - start & start byte (of start marker)
   - end & end byte (of end marker)
   - next (singly linked list of overlays)
   - next fields of start and end markers (singly linked list of markers).
   I.e. 9words plus 2 bits, 3words of which are for external linked lists.
*/
  {
    union vectorlike_header header;
    Lisp_Object plist;
    struct buffer *buffer;        /* eassert (live buffer || NULL). */
    struct itree_node *interval;
  } GCALIGNED_STRUCT;

START and END are no longer in the struct. NEXT fields are also no
longer applicable, even via itree_node struct.

In GNU Emacs 30.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
 3.24.38, cairo version 1.17.8) of 2023-07-06 built on localhost
Repository revision: d97b77e6c66db46b198c696f83458aa141794727
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12101008
System Description: Gentoo Linux

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>